#V1.2
try:
    from vcCommand import * 
    import vcMatrix, vcVector
    import csv
    from vcScript import *
    from vcHelpers.Application import *
except:
    print "Modules not found"

cmd = getCommand()
app = cmd.Application
sim = cmd.Simulation

def OnStart():
  global path, import_option, btn_click
  global Signal_Name, Signal_Type,VCSignal_Type

  path = cmd.createProperty(VC_URI, 'Select CSV')
  import_option = cmd.createProperty(VC_STRING, 'Import as', VC_PROPERTY_STEP)
  import_option.StepValues = ['ImportSignalList']
  import_option.Value = 'ImportSignalList'
  btn_click = cmd.createProperty(VC_BUTTON, 'Import')
  executeInActionPanel()
  btn_click.OnChanged = ImportFromCSV


def addSignal():
    global Signal_Name, Signal_Type,VCSignal_Type
    #comp = app.CurrentContext
    comp = app.Components
    if not comp:
        return
    # 为组件添加信号
    Foo = comp.findBehaviour(Signal_Name)
    if not Foo:
        Foo=comp.addBehaviour(VCSignal_Type,Signal_Name)
    print("Signal added to component.")

def ImportFromCSV(prop):
  '''
  Import from cvs file row format\n
  SignalName,Type
  Signal1,BoolSignal
  Signal2,IntegerSignal
  Signal3,RealSignal
  Signal4,StringSignal
  '''
  global Signal_Name, Signal_Type,VCSignal_Type

  uri = path.Value[8:]
  with open(uri) as csv_file:
    next(csv_file) #Skip the first line
    csv_reader = csv.reader(csv_file, delimiter = ',')
    for row in csv_reader:
      Signal_Name = str(row[0])
      Signal_Type = str(row[1])
      if Signal_Type == 'BoolSignal':
        VCSignal_Type = VC_BOOLEANSIGNAL

      if Signal_Type == 'StringSignal':
        VCSignal_Type = VC_STRINGSIGNAL

      if Signal_Type == 'IntegerSignal':
        VCSignal_Type = VC_INTEGERSIGNAL

      if Signal_Type == 'RealSignal':
        VCSignal_Type = VC_REALSIGNAL

def SimulationOnStartStop(sim, IsRunning):
  cmd.Enabled = True
  if IsRunning:
    cmd.Enabled = False
  else:
    cmd.Enabled = True

sim.OnStartStop = SimulationOnStartStop